/* jshint browserify: true */

'use strict';

var util = require('util');

var defaults = require('lodash.defaults');
var AnimationFrame = require('animation-frame');

var Scratchcard = require('./scratchcard');
var Painter = require('./painter');

StandaloneScratchard.Painter = Painter;

module.exports = exports = StandaloneScratchard;

function StandaloneScratchard(element, options) {
	options = (options instanceof Painter) ?
		{painter: options} :
		defaults({}, options);

	if (!(options.animationFrame instanceof AnimationFrame)) {
		options.animationFrame = new AnimationFrame(options.animationFrame);
	}

	Scratchcard.call(this, element, options);
}

util.inherits(StandaloneScratchard, Scratchcard);
